function str=struct2str(s)
% returns a string that describes the fields and values of a given
% structure
% Copyright (C) 2010-2014  Joao Hespanha

names=fieldnames(s);
str=[];
leading='(';
for i=1:length(names)
    value=getfield(s,names{i});
    if ischar(value)
        value={value};
    end
    for j=1:length(value);
        vj=value(j);
        if iscell(vj) && length(vj)==1
            vj=vj{1};
        end
        if isfloat(vj)
            if j==1
                str=sprintf('%s%s%s=%g',str,leading,names{i},vj);
            else
                str=sprintf('%s_%g',str,vj);
            end
            leading='|';
        elseif ischar(vj)
            if j==1 && length(vj)>0
                % remove paths
                vj=regexprep(vj,'^.*/([^/.]*)\.*[^/]*','$1');
                str=sprintf('%s%s%s=%s',str,leading,names{i},vj);
                leading='|';
            end
        end
    end
end
if leading=='|'
    str=[str,')'];
end
%str