function str=value2str(value)
% str=value2str(value)
%
%   Returns a character string with a value, regardless of whether the
%   value is numeric or a string
%
% Copyright (C) 2010-2014  Joao Hespanha

    if isnumeric(value)
        if length(value)==0
            str='[]';
        elseif length(value)==1
            str=sprintf('%g',value);
        else
            str='[';
            for i=1:length(value)-1
                str=[str,sprintf('%g',value(i)),','];
            end
            str=[str,sprintf('%g',value(end)),']'];
        end
    elseif islogical(value)
        if length(value)==0
            str='[]';
        elseif length(value)==1
            if value
                str='true';
            else
                str='false';
            end
        else
            str='[';
            for i=1:length(value)-1
                if value(i)
                    str=[str,'true,'];
                else
                    str=[str,'false,'];
                end
            end
            if value(end)
                str=[str,'true]'];
            else
                str=[str,'false]'];
            end
        end
    elseif ischar(value)
        str=sprintf('''%s''',value);
    elseif iscell(value)
        if length(value)>0
            str='{';
            for i=1:length(value)-1
                str=[str,value2str(value{i}),','];
            end
            str=[str,value2str(value{end}),'}'];
        else
            str='{}';
        end
    elseif strcmp(class(value),'outputWithPedigree')
        str='<to be determined from the pedigree>';
    else
        disp(value)
        error('value2str: does not know to convert ''%s'' to string\n',class(value))
    end
